include 'Vram.inc'
include 'VVram.inc'

ext Chars_
ext CharColors_

ext VVram_

dseg
Backup: public Backup
    defs VVramWidth*VVramHeight

; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    push hl | push de | push bc 
        ld hl,Vram0
        ld de,ColorMap-Vram0
        ld c,0
        call FillMemory_

        ld hl,ColorMap
        ld de,5B00h-ColorMap
        ld c,47h
        call FillMemory_

        ld hl,Backup
        ld de,VVramWidth * VVramHeight
        ld c,0
        call FillMemory_
    pop bc | pop de | pop hl
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    push af | push hl | push de | push bc
        push hl
            push de
                ld c,a
                ex de,hl
                    ld h,0
                    add hl,hl ;*2
                    add hl,hl ;*4
                    add hl,hl ;*8
                    ld bc,Chars_ 
                    add hl,bc
                ex de,hl
                sla h | sla h | sla h
                set 6,h
                ld b,CharHeight
                do
                    ld a,(de)
                    inc de
                    ld (hl),a
                    inc h
                dwnz
            pop de
            ld d,0
            ld hl,CharColors_
            add hl,de
            ld a,(hl)
        pop hl
        ld bc,ColorMap
        add hl,bc
        ld (hl),a
    pop bc | pop de | pop hl | pop af
    inc hl
ret


; void VVramToVram();
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,Backup
        exx
            ld hl,VramTop
        exx
        ld c,VVramHeight
        do
            ld b,VVramWidth
            do 
                push bc 
                    ld a,(de)
                    inc de
                    cp (hl)
                    if nz
                        ld (hl),a
                        exx
                            push de
                                ld e,a
                                call Put_
                            pop de
                        exx
                    else
                        exx
                            inc hl
                        exx
                    endif
                    inc hl
                pop bc
            dwnz
            exx
                push bc
                    ld bc,VramRowSize-VVramWidth
                    add hl,bc
                pop bc
            exx
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


cseg
FillMemory_: public FillMemory_
    push hl | push de | push bc
        ld (hl),c
        ld c,e
        ld b,d
        ld e,l
        ld d,h
        inc de
        dec bc
        ldir
    pop bc | pop de | pop hl
ret
